Index: palm/trunk/SOURCE/lpm.f90
===================================================================
--- palm/trunk/SOURCE/lpm.f90	(revision 2798)
+++ palm/trunk/SOURCE/lpm.f90	(revision 2801)
@@ -1,2 +1,4 @@
+MODULE lpm_mod
+
 !> @file lpm.f90
 !------------------------------------------------------------------------------!
@@ -25,4 +27,8 @@
 ! -----------------
 ! $Id$
+! Changed lpm from subroutine to module.
+! Introduce particle transfer in nested models.
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -139,5 +145,4 @@
 !> Particle advection
 !------------------------------------------------------------------------------!
- SUBROUTINE lpm
  
 
@@ -163,6 +168,5 @@
         ONLY: lpm_create_particle, PHASE_RELEASE
 
-    USE lpm_pack_and_sort_mod,                                                   &
-        ONLY:  lpm_sort_in_subboxes, lpm_sort_timeloop_done
+    USE lpm_pack_and_sort_mod
 
     USE particle_attributes,                                                   &
@@ -179,4 +183,24 @@
     USE pegrid
 
+ USE pmc_particle_interface,                                                &
+     ONLY: pmcp_c_get_particle_from_parent, pmcp_p_fill_particle_win,       &
+           pmcp_c_send_particle_to_parent, pmcp_p_empty_particle_win,       &
+           pmcp_p_delete_particles_in_fine_grid_area
+
+    USE pmc_interface,                                                      &
+       ONLY: nested_run
+
+ IMPLICIT NONE
+ PRIVATE
+ SAVE
+
+ INTERFACE lpm
+    MODULE PROCEDURE lpm
+ END INTERFACE lpm
+
+ PUBLIC lpm
+
+CONTAINS
+ SUBROUTINE lpm
     IMPLICIT NONE
 
@@ -424,12 +448,15 @@
 !--    Horizontal boundary conditions including exchange between subdmains
        CALL lpm_exchange_horiz
-!
-!--    Pack particles (eliminate those marked for deletion),
-!--    determine new number of particles
-       CALL lpm_sort_in_subboxes
-!
-!--    Initialize variables for the next (sub-) timestep, i.e., for marking 
-!--    those particles to be deleted after the timestep
-       deleted_particles = 0
+
+       IF ( .NOT. dt_3d_reached .OR. .NOT. nested_run )   THEN    ! IF .FALSE., lpm_sort_in_subboxes is done inside pcmp
+!
+!--       Pack particles (eliminate those marked for deletion),
+!--       determine new number of particles
+          CALL lpm_sort_in_subboxes
+!
+!--       Initialize variables for the next (sub-) timestep, i.e., for marking
+!--       those particles to be deleted after the timestep
+          deleted_particles = 0
+       ENDIF
 
        IF ( dt_3d_reached )  EXIT
@@ -437,4 +464,15 @@
        first_loop_stride = .FALSE.
     ENDDO   ! timestep loop
+!    
+!-- in case of nested runs do the transfer of particles after every full model time step
+    IF ( nested_run )   THEN
+       CALL particles_from_parent_to_child
+       CALL particles_from_child_to_parent
+       CALL pmcp_p_delete_particles_in_fine_grid_area
+
+       CALL lpm_sort_in_subboxes
+
+       deleted_particles = 0
+    ENDIF
 
 !
@@ -469,2 +507,23 @@
 
  END SUBROUTINE lpm
+
+ SUBROUTINE particles_from_parent_to_child
+    IMPLICIT NONE
+
+    CALL pmcp_c_get_particle_from_parent                         ! Child actions
+    CALL pmcp_p_fill_particle_win                                ! Parent actions
+
+    RETURN
+ END SUBROUTINE particles_from_parent_to_child
+
+ SUBROUTINE particles_from_child_to_parent
+    IMPLICIT NONE
+
+    CALL pmcp_c_send_particle_to_parent                         ! Child actions
+    CALL pmcp_p_empty_particle_win                              ! Parent actions
+
+    RETURN
+ END SUBROUTINE particles_from_child_to_parent
+
+
+END MODULE lpm_mod
Index: palm/trunk/SOURCE/lpm_boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 2798)
+++ palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 2801)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Introduce particle transfer in nested models.
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -230,8 +233,9 @@
           ENDIF
 
-          IF ( particles(n)%z >= zu(nz)  .AND.  particles(n)%particle_mask )  THEN
+          IF ( particles(n)%z >= zw(nz)  .AND.  particles(n)%particle_mask )  THEN
              IF ( ibc_par_t == 1 )  THEN
 !
 !--             Particle absorption
+                WRITE(9,*) 'particle absorption'
                 particles(n)%particle_mask  = .FALSE.
                 deleted_particles = deleted_particles + 1
@@ -239,5 +243,5 @@
 !
 !--             Particle reflection
-                particles(n)%z       = 2.0_wp * zu(nz) - particles(n)%z
+                particles(n)%z       = 2.0_wp * zw(nz) - particles(n)%z
                 particles(n)%speed_z = -particles(n)%speed_z
                 IF ( use_sgs_for_particles  .AND. &
Index: palm/trunk/SOURCE/lpm_exchange_horiz.f90
===================================================================
--- palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 2798)
+++ palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 2801)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Introduce particle transfer in nested models.
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -1175,5 +1178,5 @@
                       'Particle violated CFL-criterion: particle with id ',    &
                       particles(n)%id,' will be deleted!'   
-                      CALL message( 'lpm_check_cfl', 'PA0475', 0, 1, 0, 6, 0 )
+                      CALL message( 'lpm_check_cfl', 'PA0475', 0, 1, -1, 6, 0 )
                       particles(n)%particle_mask= .FALSE.
                    ENDIF
Index: palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- palm/trunk/SOURCE/lpm_init.f90	(revision 2798)
+++ palm/trunk/SOURCE/lpm_init.f90	(revision 2801)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Introduce particle transfer in nested models.
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -250,4 +253,7 @@
         ONLY:  get_topography_top_index_ji, surf_def_h, surf_lsm_h, surf_usm_h
 
+    USE pmc_particle_interface,                                                &
+        ONLY:  pmcp_g_init
+
     IMPLICIT NONE
 
@@ -460,4 +466,7 @@
        CASE ( 'reflect' )
           ibc_par_t = 2
+          
+       CASE ( 'nested' )
+          ibc_par_t = 3
 
        CASE DEFAULT
@@ -477,4 +486,7 @@
        CASE ( 'reflect' )
           ibc_par_lr = 2
+          
+       CASE ( 'nested' )
+          ibc_par_lr = 3
 
        CASE DEFAULT
@@ -494,4 +506,7 @@
        CASE ( 'reflect' )
           ibc_par_ns = 2
+          
+       CASE ( 'nested' )
+          ibc_par_ns = 3
 
        CASE DEFAULT
@@ -621,4 +636,6 @@
 
     ENDIF
+
+    CALL pmcp_g_init
 
 !
Index: palm/trunk/SOURCE/lpm_pack_arrays.f90
===================================================================
--- palm/trunk/SOURCE/lpm_pack_arrays.f90	(revision 2798)
+++ palm/trunk/SOURCE/lpm_pack_arrays.f90	(revision 2801)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Introduce particle transfer in nested models.
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -207,5 +210,4 @@
        ENDDO
        CALL cpu_log( log_point_s(51), 'lpm_sort_in_subboxes', 'stop' )
-       RETURN
 
     END SUBROUTINE lpm_sort_in_subboxes
Index: palm/trunk/SOURCE/lpm_write_exchange_statistics.f90
===================================================================
--- palm/trunk/SOURCE/lpm_write_exchange_statistics.f90	(revision 2798)
+++ palm/trunk/SOURCE/lpm_write_exchange_statistics.f90	(revision 2801)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Introduce particle transfer in nested models.
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -69,4 +72,5 @@
  SUBROUTINE lpm_write_exchange_statistics
  
+    USE MPI
 
     USE control_parameters,                                                    &
@@ -82,4 +86,7 @@
                trsp_count_sum, trsp_count_recv_sum
 
+    USE pmc_particle_interface,                                                &
+        ONLY:  pmcp_g_print_number_of_particles
+
     USE pegrid
 
@@ -89,4 +96,7 @@
     INTEGER(iwp) :: jp         !<
     INTEGER(iwp) :: kp         !<
+    INTEGER(iwp) :: tot_number_of_particles
+
+
 
 !
@@ -110,9 +120,22 @@
                         trsp_count_recv_sum, pnorth, trnp_count_sum,     &
                         trnp_count_recv_sum
-    CALL close_file( 80 )
 #else
     WRITE ( 80, 8000 )  current_timestep_number+1, simulated_time+dt_3d, &
                         number_of_particles
 #endif
+    CALL close_file( 80 )
+
+    IF ( number_of_particles > 0 ) THEN
+        WRITE(9,*) 'number_of_particles ', number_of_particles, current_timestep_number + 1, simulated_time + dt_3d
+    ENDIF
+
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( number_of_particles, tot_number_of_particles, 1, MPI_INTEGER,      &
+                                    MPI_SUM, comm2d, ierr)
+#else
+    tot_number_of_particles = number_of_particles
+#endif
+
+    CALL pmcp_g_print_number_of_particles (simulated_time+dt_3d, tot_number_of_particles)
 
 !
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 2798)
+++ palm/trunk/SOURCE/palm.f90	(revision 2801)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Changed lpm from subroutine to module.
+! Introduce particle transfer in nested models.
+! 
+! 2766 2018-01-22 17:17:47Z kanani
 ! Removed preprocessor directive __chem
 ! 
@@ -250,4 +254,7 @@
                pmci_modelconfiguration, pmci_parent_initialize,                &
                pmci_ensure_nest_mass_conservation
+
+    USE pmc_particle_interface,                                                 &
+        ONLY: pmcp_g_alloc_win
 
     USE radiation_model_mod,                                                   &
@@ -431,4 +438,5 @@
        ENDIF
 
+       CALL pmcp_g_alloc_win                    ! Must be called after pmci_child_initialize and pmci_parent_initialize
     ENDIF
 
